/**
 * 无返回值，无参数
 */
@FunctionalInterface
interface NoReturnNoParam {
    void method();
}

/**
 * 无返回值，有一个参数
 */
@FunctionalInterface
interface  NoReturnOneParam {
    void method(int a);
}

/**
 * 无返回值，有多个参数
 */
@FunctionalInterface
interface  NoReturnMultipleParam {
    void method(int a, int b);
}

/**
 * 有返回值，无参数
 */

@FunctionalInterface
interface ReturnNoParam {
    void method();
}

/**
 * 有返回值，有一个参数
 */
@FunctionalInterface
interface  ReturnOneParam {
    void method(int a);
}

/**
 * 有返回值，有多个参数
 */
@FunctionalInterface
interface  ReturnMultiparam {
    void method(int a, int b);
}


public class Test{
    public static void main(String[] args) {
        /**
         * 无返回值，无参数
         */
        NoReturnNoParam noReturnNoParam = () -> {
            System.out.println("NoReturnNoparam");
        };
        noReturnNoParam.method();

        /**
         * 无返回值，一个参数
         */
        NoReturnOneParam noReturnOneParam = (int a) -> {
            System.out.println("NoReturnOneparam" + a);
        };
        noReturnOneParam.method(10);

        /**
         * 无返回值，有多个参数
         */
        NoReturnMultipleParam noReturnMultipleParam = (int a, int b) -> {
            System.out.println("NoReturnMultipleParam" + a + "\t" + b);
        };
        noReturnMultipleParam.method(10, 20);


        /**
         * 有返回值，无参数
         */

        ReturnNoParam returnNoParam = ()-> {
            System.out.println("ReturnNoParam ");
            return 10;
        };
        System.out.println(returnNoParam.method());

        /**
         * 有返回值，有一个参数
         */

        ReturnOneParam returnOneParam = (int a) -> {
            System.out.print("ReturnOneparam ");
            return a;
        };
        System.out.println(returnOneParam.method(10));
        /**
         * 有返回值，有多个参数
         */
        ReturnMultiparam returnMultiParam =(int a , int b)->{
            System.out.println("ReturnMulitiParam ");
            return a+b;
        };
        System.out.println(returnMultiParam.method(10 ,20));




    }
}




